Open Infrastructure - Task #6875
Task # 6869 (Rejected): Challenge OpenStack and OpenNebula with ucloud

Create ucloud-scheduler
06/24/2019 02:18 PM - Nico Schottelius

Status: Closed Start date: 06/24/2019
Priority: Normal Due date:

Assignee: Ahmed Bilal % Done: 50%
Category: Estimated time: 0.00 hour

Target version:
PM Check date:

Description
Reads / watches keys below /vi1/vm (later probably as well /v1/networks?)

The JSON of the VM should contain a "status" field. On submit, the status should be "REQUESTED_NEW" (-> need to update
ucloud-api).

Creating VM

The scheduler watches for changes on the key prefix. If the status is REQUEST_NEW, find a suitable host for deploying the VM to.
Update the status field to "SCHEDULED_DEPLOY". Also add a new field "host" that contains the hostname of the host the VM
should be running on.

Deleting VM

The scheduler watches for changes on the key prefix. If the status is REQUEST_DELETE, do nothing -> ucloud-vm needs to react
and will update the field.

APIs

ucloud scheduler only reacts on etcd changes and does not have a direct accessible API.

History

#1 - 06/24/2019 02:22 PM - Ahmed Bilal

- Status changed from New to Seen
#2 - 06/24/2019 02:27 PM - Nico Schottelius
To be solved / undefined at the moment:
e Which component writes information about hosts? Do we have a key prefix /vi/host/<id>?
o If yes, do we need ucloud-host?
¢ Or do we use (existing) consul?
o consul is indeed an alternative to etcd for us as well
For the start:
e Create /vi/host and fill it up manually -- Balazs might also have some ideas on this

#3 - 06/24/2019 05:33 PM - Ahmed Bilal

- Status changed from Seen to In Progress

#4 - 06/24/2019 05:57 PM - Ahmed Bilal

Now, using etcd3 instead of using coreos/etcd python binding because the latter does not have support to watch a prefix e.g /vi/vm

This has implication that we can't access etcd v2 data from v3 APl and vice versa. So, instead of usual “etcdctl” we need to use 'ETCDCTL_API=3
etedctl.

#5 - 06/25/2019 01:55 PM - Ahmed Bilal
https://github.com/kragniz/python-etcd3
https://python-etcd.readthedocs.io/en/latest/

v1 is ready. It can be found here

@william and @lInu is notified to verify its working.

#6 - 06/26/2019 08:05 AM - Ahmed Bilal
- % Done changed from 0 to 50

#7 - 06/27/2019 01:22 PM - Ahmed Bilal

- Status changed from In Progress to Waiting

#8 - 06/30/2019 05:07 PM - Ahmed Bilal
- Status changed from Waiting to Feedback

#9 - 07/15/2019 04:27 PM - Ahmed Bilal

- Status changed from Feedback to In Progress

#10 - 11/28/2019 08:25 PM - Ahmed Bilal

- Status changed from In Progress to Closed

04/09/2024

22


https://code.ungleich.ch/ungleich-public/ucloud-scheduler
http://www.tcpdf.org

